import click
from scipy.spatial import distance
from transformers import AutoTokenizer, RobertaModel
import numpy as np
from model import Model
from data import Data, from_db

@click.group()
def cli():
    ...

@cli.command()
def train():
    table = from_db(Data.Titles)
    n_classes = 10
    tokenizer = AutoTokenizer.from_pretrained("roberta-base")
    model = RobertaModel.from_pretrained("roberta-base")

    def get_embeddings(titles):
        # create tokens, padding to max width 
        tokens = tokenizer(titles, add_special_tokens = True, truncation = True, padding = "max_length", return_attention_mask = True, return_tensors = "pt")
        outputs = model(**tokens)
        return outputs.last_hidden_state[:, 0, :]

    titles = table['title'].apply(str).to_list()[:10]
    get_embeddings(titles)

    # linear = torch.nn.Linear(model.config.hidden_size, n_classes)
    # act = torch.nn.Sigmoid()

    # model = Model()
    classes = act(linear(pred_y.last_hidden_state[:, 0, :])).detach()

@cli.command()
def distance():
    distances = distance.cdist(classes, classes, 'euclidean')
    np.fill_diagonal(distances, np.inf)
    min_index = (np.argmin(distances))
    closest = np.unravel_index(min_index, distances.shape)
    distances.flatten().shape


if __name__ == "__main__":
    cli()
